{
    This file is part of the Cheb's Game Engine,
    Copyright (c) 2004-2006 by Anton Rzheshevski (chebmaster@mail.ru),
      and contains source of the demo #001.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

 **********************************************************************}
 
unit _demo001_main;
 
interface
 
 uses
  SysUtils,
  {$ifdef fpc}
    un_typedefs in '../../cge/src/un_typedefs.pas',
    mo_hub in '../../cge/src/mo_hub.pas',
    mo_classes in '../../cge/src/mo_classes.pas',
    mo_textures in '../../cge/src/mo_textures.pas',
    mo_module in '../../cge/src/mo_module.pas',
    mo_controls in '../../cge/src/mo_controls.pas',
    mo_postprocess in '../../cge/src/mo_postprocess.pas'
  {$else}
    un_typedefs,
    mo_hub,
    mo_classes,
    mo_textures,
    mo_module,
    mo_controls,
    mo_postprocess
  {$endif}
  , _demo001_scene

  ;
  
const
  lightstep = 0.01;
  minbright = 0.05;
  darkfactor = 0.4;

Type

  { TDemo001 }

  TDemo001 = class (TTrulyPersistent)
  public
    tex_full, tex_halv, tex_dark, tex_bloom: glUint;
    light: float;
    Scene: TDemo001Scene;
    quality: integer;
    procedure CreateTextures;
    constructor Create;
    procedure RegisterFields; override;
    procedure BeforeSaving; override;
    procedure AfterLoading; override;
//    procedure InitTexture;
    procedure Render;
    destructor Destroy; override;
  end;

  { TDemo001Module }

  TDemo001Module = class (TModule)
  public
    Demo001: TDemo001;
    constructor Create;
    procedure OnCreate; override;
    procedure OnCycle; override;
    procedure OnPress(scancode: integer); override;
    procedure RegisterFields; override;
    procedure AfterLoading; override;
  end;


// *** REQUIRED FOR INIT ROUTINE:
type
  MyModuleType = TDemo001Module;
const
  MyModuleString: AnsiString = 'DEMO #1';
  MyModuleVersionMajor = 0;
  MyModuleVersionMinor = 1;
  MyModuleBuildNumber = {$include build.h};
// *****************

implementation

procedure TDemo001Module.RegisterFields;
begin
  RegClass(TDemo001);
  inherited;
  RegField('Demo001', @Demo001, TypeInfo(TDemo001));
end;

procedure TDemo001Module.AfterLoading;
begin
  inherited AfterLoading;
 // Load_GL_ARB_multitexture;
 // Load_GL_ARB_texture_env_add;
end;

constructor TDemo001Module.Create;
begin
  inherited;
end;

procedure TDemo001Module.OnCreate;
begin
  inherited OnCreate;
  Demo001:=TDemo001.Create;
  //Load_GL_ARB_multitexture;
  //Load_GL_ARB_texture_env_add;
end;

procedure TDemo001Module.OnCycle;
begin
  inherited OnCycle;
  if not Assigned(Demo001) then Demo001:=TDemo001.Create;
  Demo001.Render;
end;

    procedure showquality(i: integer);
    begin
      Case i of
        1: AddLog(' : ');
        2: AddLog(' : ');
        3: AddLog(' : ');
      end;
    end;
    procedure TDemo001Module.OnPress(scancode: integer);
    begin
     inherited;
     With Demo001 do
      case Scancode of
        KEY_WHEEL_UP:
          light:=light + lightstep;
        KEY_WHEEL_DOWN:
          light:=light - lightstep;
        KEY_1:
          SwitchToFullscreenMode(640, 480, 0);
        KEY_2:
          SwitchToFullscreenMode(800, 600, 0);
        KEY_ENTER:
          SwitchToWindowedMode();
        KEY_3:
          SwitchToFullscreenMode(1024, 768, 0);
        KEY_ESCAPE:
          RequestExit;
        KEY_SPACE:
          light:=1;
        KEY_4: begin
            quality:=1;
            showquality(quality);
          end;
        KEY_5:begin
            quality:=2;
            showquality(quality);
          end;
        KEY_6:begin
            quality:=3;
            showquality(quality);
          end;

     end;
    end;


{ TDemo001 }

procedure TDemo001.CreateTextures;
begin
 // if tex_halv>0 then begin glDeleteTextures(1,@tex_halv); tex_halv:=0 end;
  glGenTextures(1, @tex_halv);
  glBindTexture(GL_TEXTURE_2D, tex_halv);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
  glTexImage2D (GL_TEXTURE_2D, 0, GL_RGB, 512, 512, 0, GL_RGBA, GL_UNSIGNED_BYTE, nil);

 // if tex_full>0 then begin glDeleteTextures(1,@tex_full); tex_full:=0 end;
  glGenTextures(1, @tex_full);
  glBindTexture(GL_TEXTURE_2D, tex_full);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
  glTexImage2D (GL_TEXTURE_2D, 0, GL_RGB, 1024, 1024, 0, GL_RGBA, GL_UNSIGNED_BYTE, nil);

 // if tex_dark>0 then begin glDeleteTextures(1,@tex_dark); tex_dark:=0;end;
  glGenTextures(1, @tex_dark);
  glBindTexture(GL_TEXTURE_2D, tex_dark);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
  glTexImage2D (GL_TEXTURE_2D, 0, GL_LUMINANCE, 256, 256, 0, GL_RGBA, GL_UNSIGNED_BYTE, nil);
  
  glGenTextures(1, @tex_bloom);
  
  AddLog(' ');
  AddLog('/------------------------------------------------/');
  AddLog('  "~" - /  ');
  AddLog('    -  ');
  AddLog('   -    ');
  AddLog('     (   ).');
  AddLog('  "1" -  640480');
  AddLog('  "2" -  800600');
  AddLog('  "3" -  1024768');
  AddLog('  "Enter" -  .');
  AddLog('  "4".."6" -   ');
  AddLog('     ( ,    )');
  AddLog('  "Esc" - ');
  AddLog('  ');
  AddLog('    FPS''  FRAPS');
  AddLog('     (     )');
  AddLog('/------------------------------------------------/');
end;

constructor TDemo001.Create;
begin
  inherited;
  CreateTextures;
  quality:=3;
  light:=0.5;
end;

procedure TDemo001.RegisterFields;
begin
  RegSkip('tex_full', @tex_full, TypeInfo(glUint));
  RegSkip('tex_halv', @tex_halv, TypeInfo(glUint));
  RegSkip('tex_dark', @tex_dark, TypeInfo(glUint));
  RegSkip('tex_bloom', @tex_bloom, TypeInfo(glUint));
  RegField('light', @light, TypeInfo(float));
  RegSkipPtr('scene', @Scene);
  RegField('quality', @quality, TypeInfo(integer));
end;

procedure TDemo001.BeforeSaving;
begin
  if assigned(Scene) then Scene.Free;
end;

procedure TDemo001.AfterLoading;
begin
  CreateTextures;
end;

function min(a,b: glfloat): glfloat; begin if a<b then Result:=a else Result:=b end;
function max(a,b: glfloat): glfloat; begin if a>b then Result:=a else Result:=b end;

procedure TDemo001.Render;
var
  xo, yo, xd, yd, dwh, dhh: glFloat;
  darkv, dcol, dcol1, dcol2: glFloat;
  bp1, bp2: integer;
begin
  if light < 0.2 then light:=0.2;
  if light > 7 then light:=7;

  if not Assigned(Scene) then Scene:=TDemo001Scene.Create;
  if light < 1
    then dcol:=minbright + (1 - minbright) * sqr(light)
    else dcol:=1 + 2 * (light - 1);
  if dcol > 1.7 then dcol:=1.7;
  Scene.Render(dcol);
  if abs(light - 1) > 0.01 then begin
    glDisable(GL_DEPTH_TEST);
    glDisable(GL_ALPHA_TEST);
    glBindTexture(GL_TEXTURE_2D, tex_full);
    glCopyTexSubImage2d(GL_TEXTURE_2D, 0, 0, 0, 0, 0, DisplayWidth, DisplayHeight);
    case quality of
      1: begin bp1:=1; bp2:=4 end;
      2: begin bp1:=3; bp2:=5 end;
      3: begin bp1:=5; bp2:=5 end;
    end;
   // if glGetError = GL_INVALID_OPERATION then Die('GL_INVALID_OPERATION');
    HalvAndBlurImage(tex_full, tex_halv, 1024, DisplayWidth, DisplayHeight, 1.0, bp1);//1.0);
    if light > 1 then darkv:=max(1, light/1.7)
                 else darkv:=sqr(1-light)*(darkfactor/minbright);
    HalvAndBlurImage(tex_halv, tex_dark, 512, DisplayWidth() div 2, DisplayHeight() div 2,
      darkv , bp2);//1.0);
(*
    glClearColor(0,0,0,0);
    //glClear(GL_COLOR_BUFFER_BIT);
    glDisable(GL_BLEND);

    //glColor4f(0, 0, 1, 1);
    glColor4f(1, 1, 1, 1);

    glBlendFunc(GL_DST_COLOR, GL_SRC_ALPHA);//GL_ONE, GL_ONE);
     glMatrixMode(GL_PROJECTION);
     glLoadIdentity();
     glMatrixMode(GL_MODELVIEW);
     glLoadIdentity();
    glOrtho(0, DisplayWidth(), 0, DisplayHeight(), 0 ,1);
    xo:=DisplayWidth/1024;
    yo:=DisplayHeight/1024;
    xd:=1/1024;
    dwh:=DisplayWidth/2;
    dhh:=DisplayHeight/2;
   glBindTexture(GL_TEXTURE_2D, tex_full);
   glBegin(GL_QUADS);
     glTexCoord2f(0 + xd, 0 + xd);
     glVertex2f(0, 0); //bottom left corner
     glTexCoord2f(0 + xd, yo + xd);
     glVertex2f(0, dhh);
     glTexCoord2f(xo + xd, yo + xd);
     glVertex2f(dwh, dhh);
     glTexCoord2f(xo + xd, 0 + xd);
     glVertex2f(dwh, 0);
   glEnd;
   glBindTexture(GL_TEXTURE_2D, tex_halv);
   glCopyTexSubImage2d(GL_TEXTURE_2D, 0, 0, 0, 0, 0, DisplayWidth() div 2, DisplayHeight() div 2);
    if glGetError = GL_INVALID_OPERATION then Die('GL_INVALID_OPERATION');
   glBindTexture(GL_TEXTURE_2D, tex_halv);
   xd:=-1/512;
    dwh:=DisplayWidth/4;
    dhh:=DisplayHeight/4;
   glBegin(GL_QUADS);
     glTexCoord2f(0 + xd, 0 + xd);
     glVertex2f(0, 0); //bottom left corner
     glTexCoord2f(0 + xd, yo + xd);
     glVertex2f(0, dhh);
     glTexCoord2f(xo + xd, yo + xd);
     glVertex2f(dwh, dhh);
     glTexCoord2f(xo + xd, 0 + xd);
     glVertex2f(dwh, 0);
   glEnd;

   glBindTexture(GL_TEXTURE_2D, tex_dark);
   glCopyTexSubImage2d(GL_TEXTURE_2D, 0, 0, 0, 0, 0, DisplayWidth() div 4, DisplayHeight() div 4);
    if glGetError = GL_INVALID_OPERATION then Die('GL_INVALID_OPERATION');
*)

    dcol1:=1;//1 - sqr(1-light);
    if light > 1 then dcol1:=1;
    dcol2:=sqr(1-light);

    

PostprocessOutput(tex_full, tex_dark, 1024, 256,
                  DisplayWidth(), DisplayHeight(),
                  DisplayWidth() div 4, DisplayHeight() div 4,
                  dcol1, dcol2, //brightness
                  min(1.0, sqr(abs(1 - light))), -0.5 //blur factor
                  );
{
    glViewport(0, 0, DisplayWidth, DisplayHeight);
     glMatrixMode(GL_PROJECTION);
     glLoadIdentity();
     glMatrixMode(GL_MODELVIEW);
     glLoadIdentity();
    glOrtho(0, DisplayWidth(), 0, DisplayHeight(), 0 ,1);
    glDepthMask(GL_FALSE);
    
    
   xo:=DisplayWidth/1024;
   yo:=DisplayHeight/1024;
    dcol1:=1 - sqr(1-light);
    if light > 1 then dcol1:=1;
    glcolor4f(dcol,dcol,dcol,dcol);


//  glClearColor(0,0,0,0);
//  glClear(GL_COLOR_BUFFER_BIT);

    glBindTexture(GL_TEXTURE_2D, tex_full);
    glDisable(GL_BLEND);
//    glBlendFunc(GL_ONE, GL_SRC_COLOR);
xd:=1/2048 * sqrt(abs(1 - light));
    dwh:=DisplayWidth;
    dhh:=DisplayHeight;
   glBegin(GL_QUADS);
     glTexCoord2f(0 + xd,0 + xd);
     glVertex2f(0, 0); //bottom left corner
     glTexCoord2f( 0 + xd, yo + xd);
     glVertex2f(0, dhh);
     glTexCoord2f(xo + xd, yo + xd);
     glVertex2f(dwh, dhh);
     glTexCoord2f(xo + xd,0 + xd);
     glVertex2f(dwh, 0);
   glEnd;

    glenable(GL_BLEND);
    glBlendFunc(GL_ONE, GL_ONE);//GL_ONE, GL_ONE);
    glBindTexture(GL_TEXTURE_2D, tex_dark);
    dcol:=sqr(1-light);
    glColor4f(dcol, dcol, dcol, dcol);
   glBegin(GL_QUADS);
     glTexCoord2f(0,0);
     glVertex2f(0, 0); //bottom left corner
     glTexCoord2f( 0, yo);
     glVertex2f(0, dhh);
     glTexCoord2f(xo, yo);
     glVertex2f(dwh, dhh);
     glTexCoord2f(xo,0);
     glVertex2f(dwh, 0);
   glEnd;
   
}
  end;
end;


destructor TDemo001.Destroy;
begin
  if assigned(Scene) then Scene.Free;
  inherited Destroy;
end;

end.
